/** -*- c++ -*-
 * Copyright (C) 2008 Luke Lu (Zvents, Inc.)
 *
 * This file is part of Hypertable.
 *
 * Hypertable is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the
 * License, or any later version.
 *
 * Hypertable is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef HYPERTABLE_MASTER_METALOG_H
#define HYPERTABLE_MASTER_METALOG_H

#include "Common/String.h"
#include "MetaLogDfsBase.h"
#include "MasterMetaLogReader.h"

namespace Hypertable {

class MasterMetaLog : public MetaLogDfsBase {
public:
  MasterMetaLog(Filesystem *, const String &path);

  virtual void write(MetaLogEntry *);
  virtual void close();

  void purge(const MasterStates &);
};

typedef intrusive_ptr<MasterMetaLog> MasterMetaLogPtr;

} // namespace Hypertable

#endif // HYPERTABLE_MASTER_METALOG_H
