/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package org.hypertable.thriftgen;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.protocol.*;

/**
 * Specifies options for a shared periodic mutator
 * 
 * <dl>
 *   <dt>appname</dt>
 *   <dd>String key used to share/retrieve mutator, eg: "my_ht_app"</dd>
 * 
 *   <dt>flush_interval</dt>
 *   <dd>Time interval between flushes</dd>
 * 
 *   <dt>flags</dt>
 *   <dd>Mutator flags</dt>
 * </dl>
 */
public class MutateSpec implements TBase<MutateSpec, MutateSpec._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("MutateSpec");

  private static final TField APPNAME_FIELD_DESC = new TField("appname", TType.STRING, (short)1);
  private static final TField FLUSH_INTERVAL_FIELD_DESC = new TField("flush_interval", TType.I32, (short)2);
  private static final TField FLAGS_FIELD_DESC = new TField("flags", TType.I32, (short)3);

  public String appname;
  public int flush_interval;
  public int flags;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    APPNAME((short)1, "appname"),
    FLUSH_INTERVAL((short)2, "flush_interval"),
    FLAGS((short)3, "flags");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // APPNAME
          return APPNAME;
        case 2: // FLUSH_INTERVAL
          return FLUSH_INTERVAL;
        case 3: // FLAGS
          return FLAGS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __FLUSH_INTERVAL_ISSET_ID = 0;
  private static final int __FLAGS_ISSET_ID = 1;
  private BitSet __isset_bit_vector = new BitSet(2);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.APPNAME, new FieldMetaData("appname", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.FLUSH_INTERVAL, new FieldMetaData("flush_interval", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    tmpMap.put(_Fields.FLAGS, new FieldMetaData("flags", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(MutateSpec.class, metaDataMap);
  }

  public MutateSpec() {
    this.appname = "";

    this.flush_interval = 1000;

    this.flags = 2;

  }

  public MutateSpec(
    String appname,
    int flush_interval,
    int flags)
  {
    this();
    this.appname = appname;
    this.flush_interval = flush_interval;
    setFlush_intervalIsSet(true);
    this.flags = flags;
    setFlagsIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public MutateSpec(MutateSpec other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    if (other.isSetAppname()) {
      this.appname = other.appname;
    }
    this.flush_interval = other.flush_interval;
    this.flags = other.flags;
  }

  public MutateSpec deepCopy() {
    return new MutateSpec(this);
  }

  @Deprecated
  public MutateSpec clone() {
    return new MutateSpec(this);
  }

  public String getAppname() {
    return this.appname;
  }

  public MutateSpec setAppname(String appname) {
    this.appname = appname;
    return this;
  }

  public void unsetAppname() {
    this.appname = null;
  }

  /** Returns true if field appname is set (has been asigned a value) and false otherwise */
  public boolean isSetAppname() {
    return this.appname != null;
  }

  public void setAppnameIsSet(boolean value) {
    if (!value) {
      this.appname = null;
    }
  }

  public int getFlush_interval() {
    return this.flush_interval;
  }

  public MutateSpec setFlush_interval(int flush_interval) {
    this.flush_interval = flush_interval;
    setFlush_intervalIsSet(true);
    return this;
  }

  public void unsetFlush_interval() {
    __isset_bit_vector.clear(__FLUSH_INTERVAL_ISSET_ID);
  }

  /** Returns true if field flush_interval is set (has been asigned a value) and false otherwise */
  public boolean isSetFlush_interval() {
    return __isset_bit_vector.get(__FLUSH_INTERVAL_ISSET_ID);
  }

  public void setFlush_intervalIsSet(boolean value) {
    __isset_bit_vector.set(__FLUSH_INTERVAL_ISSET_ID, value);
  }

  public int getFlags() {
    return this.flags;
  }

  public MutateSpec setFlags(int flags) {
    this.flags = flags;
    setFlagsIsSet(true);
    return this;
  }

  public void unsetFlags() {
    __isset_bit_vector.clear(__FLAGS_ISSET_ID);
  }

  /** Returns true if field flags is set (has been asigned a value) and false otherwise */
  public boolean isSetFlags() {
    return __isset_bit_vector.get(__FLAGS_ISSET_ID);
  }

  public void setFlagsIsSet(boolean value) {
    __isset_bit_vector.set(__FLAGS_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case APPNAME:
      if (value == null) {
        unsetAppname();
      } else {
        setAppname((String)value);
      }
      break;

    case FLUSH_INTERVAL:
      if (value == null) {
        unsetFlush_interval();
      } else {
        setFlush_interval((Integer)value);
      }
      break;

    case FLAGS:
      if (value == null) {
        unsetFlags();
      } else {
        setFlags((Integer)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case APPNAME:
      return getAppname();

    case FLUSH_INTERVAL:
      return new Integer(getFlush_interval());

    case FLAGS:
      return new Integer(getFlags());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case APPNAME:
      return isSetAppname();
    case FLUSH_INTERVAL:
      return isSetFlush_interval();
    case FLAGS:
      return isSetFlags();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof MutateSpec)
      return this.equals((MutateSpec)that);
    return false;
  }

  public boolean equals(MutateSpec that) {
    if (that == null)
      return false;

    boolean this_present_appname = true && this.isSetAppname();
    boolean that_present_appname = true && that.isSetAppname();
    if (this_present_appname || that_present_appname) {
      if (!(this_present_appname && that_present_appname))
        return false;
      if (!this.appname.equals(that.appname))
        return false;
    }

    boolean this_present_flush_interval = true;
    boolean that_present_flush_interval = true;
    if (this_present_flush_interval || that_present_flush_interval) {
      if (!(this_present_flush_interval && that_present_flush_interval))
        return false;
      if (this.flush_interval != that.flush_interval)
        return false;
    }

    boolean this_present_flags = true;
    boolean that_present_flags = true;
    if (this_present_flags || that_present_flags) {
      if (!(this_present_flags && that_present_flags))
        return false;
      if (this.flags != that.flags)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    return 0;
  }

  public int compareTo(MutateSpec other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    MutateSpec typedOther = (MutateSpec)other;

    lastComparison = Boolean.valueOf(isSetAppname()).compareTo(typedOther.isSetAppname());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAppname()) {      lastComparison = TBaseHelper.compareTo(this.appname, typedOther.appname);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetFlush_interval()).compareTo(typedOther.isSetFlush_interval());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetFlush_interval()) {      lastComparison = TBaseHelper.compareTo(this.flush_interval, typedOther.flush_interval);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetFlags()).compareTo(typedOther.isSetFlags());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetFlags()) {      lastComparison = TBaseHelper.compareTo(this.flags, typedOther.flags);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // APPNAME
          if (field.type == TType.STRING) {
            this.appname = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // FLUSH_INTERVAL
          if (field.type == TType.I32) {
            this.flush_interval = iprot.readI32();
            setFlush_intervalIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // FLAGS
          if (field.type == TType.I32) {
            this.flags = iprot.readI32();
            setFlagsIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    if (!isSetFlush_interval()) {
      throw new TProtocolException("Required field 'flush_interval' was not found in serialized data! Struct: " + toString());
    }
    if (!isSetFlags()) {
      throw new TProtocolException("Required field 'flags' was not found in serialized data! Struct: " + toString());
    }
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.appname != null) {
      oprot.writeFieldBegin(APPNAME_FIELD_DESC);
      oprot.writeString(this.appname);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldBegin(FLUSH_INTERVAL_FIELD_DESC);
    oprot.writeI32(this.flush_interval);
    oprot.writeFieldEnd();
    oprot.writeFieldBegin(FLAGS_FIELD_DESC);
    oprot.writeI32(this.flags);
    oprot.writeFieldEnd();
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("MutateSpec(");
    boolean first = true;

    sb.append("appname:");
    if (this.appname == null) {
      sb.append("null");
    } else {
      sb.append(this.appname);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("flush_interval:");
    sb.append(this.flush_interval);
    first = false;
    if (!first) sb.append(", ");
    sb.append("flags:");
    sb.append(this.flags);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (appname == null) {
      throw new TProtocolException("Required field 'appname' was not present! Struct: " + toString());
    }
    // alas, we cannot check 'flush_interval' because it's a primitive and you chose the non-beans generator.
    // alas, we cannot check 'flags' because it's a primitive and you chose the non-beans generator.
  }

}

